#version 330

//input values form shader
in vec2 fragmentUV;

//output values
layout(location = 0) out vec4 fragColor;

//constant values
uniform sampler2D colorTexture;
uniform sampler2D colorTextureOriginal;
uniform vec3 screen;

void main() {

// material
vec3 diffusePart = texture2D( colorTexture, fragmentUV ).rgb;

float x = screen.x;
float y = screen.y;
float bloomstage = screen.z;
float t = 0.5f;
float i = 4.0f;

vec3 fragColor1 = vec3(0.0f,0.0f,0.0f);
if(bloomstage==1.0f){
fragColor1 = vec3(max(diffusePart.x - t, 0.0),max(diffusePart.y - t, 0.0),max(diffusePart.z - t, 0.0)) * i;
}
if(bloomstage==2.0f){
fragColor1 = vec3(
texture2D( colorTexture, fragmentUV + vec2(10.0f/x,0.0f)).rgb * 1.0f /321.0f +
texture2D( colorTexture, fragmentUV + vec2(9.0f/x,0.0f)).rgb * 4.0f /321.0f +
texture2D( colorTexture, fragmentUV + vec2(8.0f/x,0.0f)).rgb * 7.0f /321.0f +
texture2D( colorTexture, fragmentUV + vec2(7.0f/x,0.0f)).rgb * 10.0f /321.0f +
texture2D( colorTexture, fragmentUV + vec2(6.0f/x,0.0f)).rgb * 13.0f /321.0f +
texture2D( colorTexture, fragmentUV + vec2(5.0f/x,0.0f)).rgb * 16.0f /321.0f +
texture2D( colorTexture, fragmentUV + vec2(4.0f/x,0.0f)).rgb * 19.0f /321.0f +
texture2D( colorTexture, fragmentUV + vec2(3.0f/x,0.0f)).rgb * 22.0f /321.0f +
texture2D( colorTexture, fragmentUV + vec2(2.0f/x,0.0f)).rgb * 25.0f /321.0f +
texture2D( colorTexture, fragmentUV + vec2(1.0f/x,0.0f)).rgb * 28.0f /321.0f +
texture2D( colorTexture, fragmentUV + vec2(0.0f/x,0.0f)).rgb * 31.0f /321.0f +
texture2D( colorTexture, fragmentUV + vec2(-1.0f/x,0.0f)).rgb * 28.0f /321.0f +
texture2D( colorTexture, fragmentUV + vec2(-2.0f/x,0.0f)).rgb * 25.0f /321.0f +
texture2D( colorTexture, fragmentUV + vec2(-3.0f/x,0.0f)).rgb * 22.0f /321.0f +
texture2D( colorTexture, fragmentUV + vec2(-4.0f/x,0.0f)).rgb * 19.0f /321.0f +
texture2D( colorTexture, fragmentUV + vec2(-5.0f/x,0.0f)).rgb * 16.0f /321.0f +
texture2D( colorTexture, fragmentUV + vec2(-6.0f/x,0.0f)).rgb * 13.0f /321.0f +
texture2D( colorTexture, fragmentUV + vec2(-7.0f/x,0.0f)).rgb * 10.0f /321.0f +
texture2D( colorTexture, fragmentUV + vec2(-8.0f/x,0.0f)).rgb * 7.0f /321.0f +
texture2D( colorTexture, fragmentUV + vec2(-9.0f/x,0.0f)).rgb * 4.0f /321.0f +
texture2D( colorTexture, fragmentUV + vec2(-10.0f/x,0.0f)).rgb * 1.0f /321.0f);
}
if(bloomstage==3.0f){
fragColor1 = vec3(
texture2D( colorTexture, fragmentUV + vec2(0.0f,10.0f/y)).rgb * 1.0f /321.0f +
texture2D( colorTexture, fragmentUV + vec2(0.0f,9.0f/y)).rgb * 4.0f /321.0f +
texture2D( colorTexture, fragmentUV + vec2(0.0f,8.0f/y)).rgb * 7.0f /321.0f +
texture2D( colorTexture, fragmentUV + vec2(0.0f,7.0f/y)).rgb * 10.0f /321.0f +
texture2D( colorTexture, fragmentUV + vec2(0.0f,6.0f/y)).rgb * 13.0f /321.0f +
texture2D( colorTexture, fragmentUV + vec2(0.0f,5.0f/y)).rgb * 16.0f /321.0f +
texture2D( colorTexture, fragmentUV + vec2(0.0f,4.0f/y)).rgb * 19.0f /321.0f +
texture2D( colorTexture, fragmentUV + vec2(0.0f,3.0f/y)).rgb * 22.0f /321.0f +
texture2D( colorTexture, fragmentUV + vec2(0.0f,2.0f/y)).rgb * 25.0f /321.0f +
texture2D( colorTexture, fragmentUV + vec2(0.0f,1.0f/y)).rgb * 28.0f /321.0f +
texture2D( colorTexture, fragmentUV + vec2(0.0f,0.0f/y)).rgb * 31.0f /321.0f +
texture2D( colorTexture, fragmentUV + vec2(0.0f,-1.0f/y)).rgb * 28.0f /321.0f +
texture2D( colorTexture, fragmentUV + vec2(0.0f,-2.0f/y)).rgb * 25.0f /321.0f +
texture2D( colorTexture, fragmentUV + vec2(0.0f,-3.0f/y)).rgb * 22.0f /321.0f +
texture2D( colorTexture, fragmentUV + vec2(0.0f,-4.0f/y)).rgb * 19.0f /321.0f +
texture2D( colorTexture, fragmentUV + vec2(0.0f,-5.0f/y)).rgb * 16.0f /321.0f +
texture2D( colorTexture, fragmentUV + vec2(0.0f,-6.0f/y)).rgb * 13.0f /321.0f +
texture2D( colorTexture, fragmentUV + vec2(0.0f,-7.0f/y)).rgb * 10.0f /321.0f +
texture2D( colorTexture, fragmentUV + vec2(0.0f,-8.0f/y)).rgb * 7.0f /321.0f +
texture2D( colorTexture, fragmentUV + vec2(0.0f,-9.0f/y)).rgb * 4.0f /321.0f +
texture2D( colorTexture, fragmentUV + vec2(0.0f,-10.0f/y)).rgb * 1.0f /321.0f) + texture2D( colorTextureOriginal, fragmentUV ).rgb;
}
if(bloomstage==4.0f){
fragColor1 = diffusePart;
}
//fragColor = vec4(fragColor1 + diffusePart, 1.0f);
fragColor = vec4(fragColor1, 1.0f);


}
