#version 330

//input values form shader
in vec2 fragmentUV;

//output values
layout(location = 0) out vec4 fragColor;

//constant values
uniform sampler2D colorTexture;
uniform sampler2D colorPrev1;
uniform sampler2D colorPrev2;

void main() {

// material
vec3 diffusePart = texture2D( colorTexture, fragmentUV ).rgb;
vec3 diffusePrev1 = texture2D( colorPrev1, fragmentUV ).rgb;
vec3 diffusePrev2 = texture2D( colorPrev2, fragmentUV ).rgb;

vec3 weight = vec3(0.6f,0.3f,0.1f);

fragColor = vec4(diffusePart*weight.x + diffusePrev1*weight.y + diffusePrev2*weight.z, 1.0f);


}
